"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.mapWithFeedback = void 0;
var _reduceLazy_1 = require("./_reduceLazy");
var purry_1 = require("./purry");
function mapWithFeedback() {
    return (0, purry_1.purry)(mapWithFeedbackImplementation, arguments, lazyImplementation);
}
exports.mapWithFeedback = mapWithFeedback;
var mapWithFeedbackImplementation = function (data, reducer, initialValue) { return (0, _reduceLazy_1._reduceLazy)(data, lazyImplementation(reducer, initialValue)); };
var lazyImplementation = function (reducer, initialValue) {
    var previousValue = initialValue;
    return function (currentValue, index, data) {
        previousValue = reducer(previousValue, currentValue, index, data);
        return { done: false, hasNext: true, next: previousValue };
    };
};
