"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.uniqueWith = void 0;
var _reduceLazy_1 = require("./_reduceLazy");
var purry_1 = require("./purry");
function uniqueWith() {
    return (0, purry_1.purry)(uniqueWithImplementation, arguments, lazyImplementation);
}
exports.uniqueWith = uniqueWith;
var uniqueWithImplementation = function (data, isEquals) { return (0, _reduceLazy_1._reduceLazy)(data, lazyImplementation(isEquals)); };
var lazyImplementation = function (isEquals) {
    return function (value, index, data) {
        return data.findIndex(function (otherValue) { return isEquals(value, otherValue); }) === index
            ? { done: false, hasNext: true, next: value }
            : { done: false, hasNext: false };
    };
};
