import { _reduceLazy } from "./_reduceLazy";
import { purry } from "./purry";
export function mapWithFeedback() {
    return purry(mapWithFeedbackImplementation, arguments, lazyImplementation);
}
var mapWithFeedbackImplementation = function (data, reducer, initialValue) { return _reduceLazy(data, lazyImplementation(reducer, initialValue)); };
var lazyImplementation = function (reducer, initialValue) {
    var previousValue = initialValue;
    return function (currentValue, index, data) {
        previousValue = reducer(previousValue, currentValue, index, data);
        return { done: false, hasNext: true, next: previousValue };
    };
};
